
require 'wwwhtml.pl';

package HTMLHandler;

#
# Object: HTMLHandler
#
#
# Instance variables:
#
#
# Methods
#

@ISA = qw(DocumentHandler);

grep($stoplist{$_}++,
     qw(to in on around over under the a an is this be of if or its and by
	as ));

#
# Create a new handler for the current walker process.
#
sub new
{
    my($class, $mdb) = @_;
    my $self = {};
    bless $self;
    $$self{'OBJ_config_file_entries'} = {};

    $self->generate_accessors('mdb');

    $self->set_mdb($mdb);

    print "HTMLHandler created $self\n";
    return $self;
}

#
# Check to see if the retrieved url is an image
#
sub got_image
{
    my($self, $suffix, $content_type) = @_;

    return 0;
}

# 
# Check to see if the retrieved url is an audio file
#
sub got_sound
{
    my($self, $suffix) = @_;

    return 0;
}

#
# Check suffix on current url to see if this handler should be used.
#
sub accepts_suffix
{
    my($self, $suffix) = @_;

    return $suffix eq 'html';
}

#
# Check content of Web page to see if this handler should be used.
#
sub accepts_content
{
    my($self, $content) = @_;

    return 0; 
}

# 
# Check content type of Web page to see if this handler should be used.
#
sub accepts
{
    my($self, $content_type) = @_;

    if ("\L$content_type" eq "text/html")
    {
	return 1;
    }
    else
    {
	return 0;
    }
}

#
# Extract links from within the Web page.
#
sub handle
{
    my($self, $url, $content_glob, $headers_glob) = @_;
    my($rc);
    local(@links, @labs, @lorig, @ltype, *headers, *content);
    my(%mlinks, $raw_content, $words, @h);
    my($l);

    print "Handling HTML $url\n";

    *headers = $headers_glob;
    *content = $content_glob;

#    print "content is $content\n";

#    $raw_content = $content;

    &wwwhtml::extract_links($url, *headers, *content,
			    *links, *labs, *lorig, *ltype);

    for $l (@links)
    {
	next if $l eq '';
	$mlinks{$l} = 1;
    }

    #
    # Don't do this, since mdb doesn't use it.
#    $words = $self->extract_content($raw_content);

    @h = ();
    my($k, $v);
    while (($k, $v) = each(%headers))
    {
	push(@h, $k, $v) unless $v eq '';
    }
#    print "flattened headers: \n";
#    for (@h)
#    {
#	print "--> $_\n";
#    }
    @links = keys %mlinks;
    
    #
    # Ship it off!
    #
    # Don't send the content *or* the word list, since the
    # mdb doesn't use either.
    #
    Nexus::rpc_async($self->mdb, "new_page",
		    $url->as_string, '', '',
		    int(@h), int(@links),
		    @h, @links);
}

#
# Remove content from Web page.
#
sub extract_content
{
    my($self, $content) = @_;
    my($word, %words, $rc);

    $content =~ s/\s+/ /g;    

    # Remove all of the formatting
    
    $content =~ s#<[^<]+>##g;

    # Remove punctuation

    $content =~ s/[^a-zA-Z\s]//g;

    # Create unique word list

    for $word (split(/\s+/, $content))
    {
	$word = "\L$word";
	next if $stoplist{$word};
	$words{$word}++;
    }
    
    for $word (sort {$words{$b} <=> $words{$a}} keys %words)
    {
	$rc .= "$word $words{$word}\n";
    }
    return $rc;
}
     
1;
