
package Object;

#
# Object: Object (generic)
#
# Instance variables: None

sub boot
{
    Nexus::register_handler("info", "info",
			    method_call => 1,
			    unpack_buffer => 1);
    Nexus::register_handler("quit", "quit",
			    method_call => 1,
			    unpack_buffer => 1);
    Nexus::register_handler("set_params", "set_params",
			    method_call => 1,
			    unpack_buffer => 1);
}

sub set_params
{
    my($self, %params) = @_;
    my($nkeys, $key, $val);
    my($i, $len);

    print "$self set_params\n";
    while (($key, $val) = each(%params))
    {
	print "got k=$key val=$val\n";
	eval "\$self->set_$key(\$val)";
    }
}

sub info
{
    my($self) = @_;
    my($k, $v);

    print "$self info method!\n";
    print "Instance vars:\n";
    while (($k, $v) = each %$self)
    {
	print "    $k => $v\n";
    }
}

sub quit
{
    my($self) = @_;
    print "$self quit method!\n";
    &Nexus::destroy_current_context();
}

#
# Method handle_config
#
# If $self is a ref to an associative array,  and it has an
# entry keyed OBJ_config_file_entries, look in that hash to see if
# $name is a config value. If the value exists and is reference, assign
# $value to the reference. Otherwise assign it to $$self{$name}.
#
# Arguments:
#	name:	Name of config file entry
#	value:	Config file entry value
#

sub handle_config
{
    my($self, $name, $value) = @_;
    my($cf_entries, $valref);

    if (defined($cf_entries = $$self{'OBJ_config_file_entries'}))
    {
	if (defined($valref = $$cf_entries{$name}))
	{
	    if (ref($valref))
	    {
		$$valref = $value;
	    }
	    else
	    {
		eval "\$self->set_$name(\$value)";
#		$$self{$name} = $value;
	    }
	    return 1;
	}
    }

    return 0;
}

#
# Method generate_accessors
#
# Generate the set of accessor functions the given set of instance
# variables.
#

sub generate_accessors
{
    my($self, @methods) = @_;
    my($method, $obj);

    if ($obj = ref($self))
    {
	for $method (@methods)
	{
	    eval "sub $method { \$_[0]->{'_$method'}; }";
	    eval "sub set_$method { \$_[0]->{'_$method'} = \$_[1]; }";
	}
    }
}

sub signal_caught
{

}


sub dump
{
    my $self = shift;
    my($k, $v);

    print "Dumping $self\n";
    
    for $k (keys %$self)
    {
	print "    ", $k, " <", $$self{$k}, ">\n";
    }
}

sub fatal
{
    my($self) = shift;
    my $i;

    warn "Fatal error: ", @_;

    print "Traceback:\n";
    for ($i = 0;; $i++)
    {
	if (($package,$filename,$line) = caller($i))
	{
	    print "$filename:$line\n";
	}
	else
	{
	    last;
	}
    }

#    &::sig_handler('fatal');
    &::checkpoint(1);
	    
    exit 1;
}

1;
